---
title: XRPermissionDescriptor.requiredFeatures
slug: Web/API/XRPermissionDescriptor/requiredFeatures
tags:
  - API
  - AR
  - Mixed
  - Permissions
  - Property
  - Reality
  - Reference
  - Reference Space
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRPermissionDescriptor
  - augmented
  - features
  - requiredFeatures
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p><span class="seoSummary">The {{domxref("XRPermissionDescriptor")}} dictionary's <code><strong>requiredFeatures</strong></code> property should be set prior to calling {{domxref("permissions.query", "navigator.permissions.query()")}} to a list of WebXR features which must be supported for the app to work.</span> This ensures that permissions are checked as applicable to ensure that those features are available upon request.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrPermissionDescriptor</em> = {
   mode: <em>xrSessionMode</em>,
   requiredFeatures: <em>reqFeatureList</em>,
   optionalFeatures: <em>optFeatureList
</em>};

<em>xrPermissionDescriptor</em>.requiredFeatures = <em>reqFeatureList</em>;
<em>reqFeatureList</em> = <em>xrPermissionDescriptor</em>.requiredFeatures;</pre>

<h3 id="Value">Value</h3>

<p>An array of strings indicating the WebXR features which <em>must</em> be available for use by the app or site. The permissions check will be performed in such a manner as to verify that all features in the list are available for use with the user's permission.</p>

<p>Currently, all features are members of the {{domxref("XRReferenceSpaceType")}} enumerated type, indicating the reference space types that your app would like permission to use, but can operate without. Future editions of WebXR may add more recognized features.</p>

<p>The permitted values are:</p>

<p>{{page("/en-US/docs/Web/API/XRReferenceSpaceType", "Reference space descriptors")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<h2 id="Examples">Examples</h2>

<p>In this example, permissions are checked to ensure that the user has granted permission for the site or app to use immersive augmented reality mode with the <code>local-floor</code> reference space (presumably since the user is unlikely to start to fly).</p>

<pre class="brush: js">let xrPermissionDesc = {
  name: "xr",
  mode: "immersive-ar",
  requiredFeatures: [ "local-floor" ]
};

if (navigator.permissions) {
  navigator.permissions.query(xrPermissionDesc).then(({state}) =&gt; {
    switch(state) {
      case "granted":
        setupXR();
        break;
      case "prompt":
        promptAndSetupXR();
        break;
      default:
        /* do nothing otherwise */
       break;
  }
  .catch(err) {
    console.log(err);
  }
} else {
  setupXR();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrpermissiondescriptor-requiredfeatures','XRPermissionDescriptor.requiredFeatures')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRPermissionDescriptor.requiredFeatures")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Permissions_and_security">Permissions and security for WebXR</a></li>
 <li>{{domxref("XRPermissionStatus")}}</li>
 <li>{{domxref("navigator.permissions")}} and {{domxref("WorkerNavigator.permissions")}}</li>
 <li>{{domxref("Permissions")}}</li>
</ul>
